#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

#配置插件安装目录
install_path=/www/server/panel/plugin/mffind
#pip需要的包
requirements_path=/www/server/panel/plugin/mffind/requirements.txt

GetPackManager(){
	if [ -f "/usr/bin/yum" ] && [ -f "/etc/yum.conf" ]; then
		PM="yum"
	elif [ -f "/usr/bin/apt-get" ] && [ -f "/usr/bin/dpkg" ]; then
		PM="apt-get"		
	fi
}
System_Lib(){
	if [ "${PM}" == "yum" ] || [ "${PM}" == "dnf" ] ; then
		Pack="python-devel python3-devel python3-dev swig"
		${PM} install ${Pack} -y
	elif [ "${PM}" == "apt-get" ]; then
		Pack="python-dev python3-dev python3-devel swig"
		${PM} install ${Pack} -y
	fi
}

#安装
Install()
{
	
	echo '正在安装...'
	#export C_INCLUDE_PATH=/usr/include/python3.6:$C_INCLUDE_PATH
	#export LUS_INCLUDE_PATH=/usr/include/python3.6:$CPLUS_INCLUDE_PATH
	GetPackManager
	System_Lib
	#==================================================================
	cd $install_path
	#yum install python3-devel
	
	#依赖安装开始
	if [ -f "/www/server/panel/pyenv/bin/python" ]; then
		#ARG C_INCLUDE_PATH='/www/server/panel/pyenv/include/python3.7m'
		#export C_INCLUDE_PATH
		#export LUS_INCLUDE_PATH=/www/server/panel/pyenv/include/python3.7m
		#export CPPFLAGS=-I/www/server/panel/pyenv/include/python3.7m
		#cat $requirements_path | sed -e '/^\s*#.*$/d' -e '/^\s*$/d' | xargs -n 1 /www/server/panel/pyenv/bin/python -m pip install
		/www/server/panel/pyenv/bin/python -m pip install moofei
		/www/server/panel/pyenv/bin/python -m pip install --upgrade	moofei
    else
		#cat $requirements_path | sed -e '/^\s*#.*$/d' -e '/^\s*$/d' | xargs -n 1 pip install
		pip install moofei
		pip install	--upgrade moofei
	fi

	#依赖安装结束
	#==================================================================

	echo '================================================'
	echo '安装完成'
}

#安装全部Moofei插件
InstallAllPlugin(){
	if [ -f "/www/server/panel/pyenv/bin/python" ]; then
		cat $requirements_path | sed -e '/^\s*#.*$/d' -e '/^\s*$/d' | xargs -n 1 /www/server/panel/pyenv/bin/python -m pip install
	else
		cat $requirements_path | sed -e '/^\s*#.*$/d' -e '/^\s*$/d' | xargs -n 1 pip install
	fi
}

#卸载
Uninstall()
{
	rm -rf $install_path
}

#操作判断
if [ "${1}" == 'install' ];then
	Install
elif [ "${1}" == 'uninstall' ];then
	Uninstall
elif [ "${1}" == 'install-all-plugin' ];then
	InstallAllPlugin	
else
	echo 'Error!';
fi
