#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
Mufei _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfFind
#+--------------------------------------------------------------------

__all__ = ['mffind_main']

import sys,os,json,time
from flask import request
import threading
isWin = sys.platform=='win32'
basedir = os.path.abspath(os.path.dirname(__file__))
plugin_path = "/www/server/panel/plugin/mffind/"
panelTaskPath = '/tmp/panelTask.pl'
installPath = '/tmp/panelExec.log'
if not os.path.isdir(plugin_path):
    if os.getenv("BT_PANEL"):
        plugin_path = os.getenv("BT_PANEL").rstrip('/').rstrip('\\')+'/plugin/mffind/'
        if isWin: 
            panelTaskPath = os.getenv("BT_PANEL").rstrip('/').rstrip('\\')+'/data/panelTask.pl'
            installPath = os.getenv("BT_PANEL").rstrip('/').rstrip('\\')+'/data/panelExec.log'
    else:
        plugin_path = basedir.rstrip('/').rstrip('\\')+'/'
       
try:
    from moofei._app import static_file, finds, stopPros, infoPros
    from moofei.valid.flask_valid import call_request_wrap
    from moofei.__version__ import __version__ as moofei_version
except:
    moofei_version = None
    from BTPanel import app
    if not app.config.get('LOADING_MOOFEI'):
        if os.path.isfile(installPath): os.remove(installPath)
        app.config['LOADING_MOOFEI'] = 1
        cmd = 'btpython -m pip install moofei > %s'%installPath #os.system(cmd)
        threading.Thread(target=os.system, args=(cmd,)).start()


class mffind_main:
    __plugin_path = plugin_path
    __config = None

    #构造方法
    def  __init__(self):
        pass

    def index(self,args):
        return {'data':{'moofei_version':moofei_version},'status':1}  

    def find_html(self,args):
        return {'data':{},'status':1}
        
    def get_find(self,args): 
        return call_request_wrap(infoPros)() 
        
    def stop_find(self, args):
        return call_request_wrap(stopPros)() 
        
    def find(self, args):
        if moofei_version is None:
            if os.path.isfile(installPath):
                msg = open(installPath).read()+'\n以上为正在程序安装信息;请稍后!'
            else:
                msg = ""
            return msg or "组件未安装成功;请CMD管理员命令安装[btpython -m pip install moofei]"
        return call_request_wrap(finds)()
    
    def find_download(self, args):
        fpath = request.args.get('file')
        if fpath.startswith(('/','~')) or ':' in fpath:
            pass
        else:
            fpath = os.path.join(plugin_path, '..', '..', fpath)
        
        as_attachment = False if  request.args.get('is_view') else True
        if not as_attachment and os.path.isfile(fpath):
            from flask import Response
            return Response(open(fpath,'rb').read(), mimetype='text/txt')
        return static_file(fpath, is_static=0, as_attachment=as_attachment) 
        
    def install_all_plugin(self, args):    
        import sqlite3
        cmdPath = os.path.join(plugin_path,'install.sh')
        dbPath = os.path.join(plugin_path,'..','..','data/default.db')
        if isWin:
            requirementsPath = plugin_path+'requirements.txt'
            cmd = 'for /f "delims=" %a in ('+requirementsPath+') do (btpython -m pip install %a) >> '+installPath
            threading.Thread(target=os.system, args=(cmd,)).start()
        else:    
            conn = sqlite3.connect(dbPath)
            cur = conn.cursor()
            execstr = cmd = "bash %s install-all-plugin"%cmdPath
            sql = "insert into tasks(id,name,type,status,addtime,execstr)values(?,?,?,?,?,?)"
            cur.execute(sql, [None,'install[mffind-0.2]','execshell','0',time.strftime('%Y-%m-%d %H:%M:%S'),execstr])
            conn.commit()
            cur.close()
            conn.close()
        open(panelTaskPath,'w').write('True')    
        return {'data':{'cmd':cmd},'status':1}

        
    

    

    
               

    
       

    